/*
hclose.c Version 0.1.0  Hash close database
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

#include <bthash.h>

int hclose(hashfmt *hshhdr)
   {
   BOOL  bResult;
   DWORD msgerr;
   LPVOID lpMsgBuf;
   char dbname[256];
   hshhdr->reason = 0;
   strcpy(dbname,hshhdr->dbname);
   bResult = CloseHandle(hshhdr->hndl);
   if (!bResult)
      {
      msgerr = GetLastError();
      FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
         FORMAT_MESSAGE_FROM_SYSTEM |
         FORMAT_MESSAGE_IGNORE_INSERTS,
         NULL,            /* source */
         msgerr,
         MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
         (LPTSTR) &lpMsgBuf,
         0,               /* message length */
         NULL);           /* insertion values */
      fprintf(stderr,"hclose: %s\n", lpMsgBuf);
      LocalFree(lpMsgBuf);
      fprintf(stderr,"hclose: CloseHandle "
         "error for %s\n", dbname);
      return(SYS_ERR + msgerr);
      } /* if close error */
   free(hshhdr->node);
   free(hshhdr->nodenext);
   free(hshhdr->nodeprev);
   free(hshhdr);
   return(0);
   } /* hclose */
